﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CapstoneProject.EngineClasses
{
    class Farming: FoodResource
    {
        float staticNAR;
        float farmTime;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="habitat"></param>
        public Farming(Habitat habitat)
            : base(3390, 120, habitat.MaxFarm, 0, 0)
        {
            float extraValue = 0.25f * (1000 - habitat.MaxBarley / 300) * 3000; // farm possible per hectare * max number of farmable hectares
            maxValue = (habitat.MaxBarley / 300)/600 * 100 * 4500; // taken from provided code (carryingCapacity = habitat.cerealGradient*4500;)
            farmTime = (1 / (2 * ((habitat.MaxBarley / 300) + maxValue))) * 365 + 120; // time to farm * days in the year + handle time(time to harvest)
            //Console.WriteLine(farmTime);
            staticNAR = (3390 / (farmTime) - 6*2); // energy/time to farm - energy to harvest
        }

        new public void calculateNAR()
        {
            NAR = staticNAR;
        }

        new public void grow()
        {
            currentValue = maxValue;
        }

        new public float[] calculateEnergy(float energyNeeded, float timeAvail)
        {
            float[] output = new float[] { 0, 0 };
            float catchable = Math.Min(currentValue, timeAvail / farmTime); // cant catch more than available or more than time allows
            float needed = (energyNeeded / NAR) / handleTime;
            float caught = Math.Min(catchable, needed);
            //Console.WriteLine("needed: " + needed + " caught: " + caught + " catchable: " + catchable + "");

            output[0] = NAR * (farmTime) * caught;
            output[1] = (farmTime) * caught;
            currentValue = Math.Max(0, currentValue - caught);

            return output;
        }
    }
}
