﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CapstoneProject.EngineClasses
{
    // Fairly simple class that mostly is used to contain parameters used by many cells with the grid, simulates a real world habitat
    class Habitat
    {
        #region Attributes
        World world; // the world that the habitat is connected to

        string name; // the descriptive name of the habitat

        float maxPrey; // maximum amount of prey the habitat can sustain
        float maxBarley; // maximum amount of Barley the habitat can sustain
        float maxFarm; // maximum amount of farm the habitat can provide
        #endregion

        #region Properties
        public string Name
        {
            get { return name; }
        }

        public float MaxPrey
        {
            get { return maxPrey; }
        }

        public float MaxBarley
        {
            get { return maxBarley; }
        }

        public float MaxFarm
        {
            get { return maxFarm; }
        }
        #endregion

        /// <summary>
        /// The only possible contructor, all details must be provided for a valid habitat to be created
        /// </summary>
        /// <param name="world">The world in which the habitat exists</param>
        /// <param name="name">The descriptive name of the habitat</param>
        /// <param name="maxPrey">Maximum amount of prey sustained by the habitat</param>
        /// <param name="maxBarley">Maxmimum amount of barley sustained by the habitat</param>
        /// <param name="maxFarm">Maximum amount of farm provided by the habitat</param>
        public Habitat(World world, string name, float maxPrey, float maxBarley, float maxFarm)
        {
            this.world = world;
            this.name = name;

            this.maxPrey = maxPrey;
            this.maxBarley = maxBarley;
            this.maxFarm = maxFarm;
        }
    }
}
